import bpy, bmesh
from . PS_LIB import *
from . PS_PROFILER import *

def EXTRUDER_GEN(shiftMOD,fuse,gap,reverse):
    # _________OP VARIABLES
    
    bpy.ops.object.editmode_toggle()
    bpy.ops.object.editmode_toggle()

    samples = 0
    use_curve= False
    PATH=None

    if use_curve:

        PROFILE = curve_extrude(samples)[1:-1]
        PROFILE.reverse()
        INV=1

    else:    
        PF= FaceProfile()[0]
        PF_EX=[]
        try:
            Zlen, PzMIN, PzMAX, PF = ZLEN_MIN_MAX(PF)
        except:
            return ['ERROR', 'profile error'] # @@@ ERROR @@@
        
        for v in PF:
            if not v[0]==0: PF_EX.append(v)

        
        PF_EX.sort(key=lambda z: z[2])
        
        Xmax_down=set()
        Xmax_up=set()

        Xmax_down.add(PF_EX[0][0])
        Xmax_up.add(PF_EX[-1][0])
        PROFILE=[]

        if reverse:
            F_MOD=1/max(Xmax_up)
            PF_EX.reverse()
            INV=-1
            for i in PF_EX:
                if not 0==i[0]:
                    PROFILE.append(( i[0]*F_MOD,0,i[2]*F_MOD ))

        else:
            F_MOD=1/max(Xmax_down)
            INV=1
            for i in PF_EX:
                if not 0==i[0]:
                    PROFILE.append((i[0]*F_MOD, 0, (i[2]+Zlen)*F_MOD ))

    
    if len(PROFILE)<1:return

    # ______________________LOAD GEO 

    automerge_changed=False
    if bpy.context.scene.tool_settings.use_mesh_automerge == True:
        automerge_changed=True
        bpy.context.scene.tool_settings.use_mesh_automerge = False



    obj = bpy.context.object
    me = obj.data
    bm = bmesh.from_edit_mesh(me)

    FUSE_PATH=set()
    PATH = set(f for f in bm.faces if f.select)

    if not fuse:
        for f in PATH:
            nu_f = f.copy()
            FUSE_PATH.add(nu_f)
               
        for f in PATH:
            f.select=False   

        for f in FUSE_PATH: 
            f.select=True
    
        bpy.ops.mesh.remove_doubles(use_unselected=False)
        PATH=FUSE_PATH
        
    DIR_X,DIR_Y,DIR_Z=0,0,0
    AREA=0 
    SCALE=0

    for f in PATH:
        f.select = True
        DIR_X+=f.normal.x
        DIR_Y+=f.normal.y
        DIR_Z+=f.normal.z
        AREA+=f.calc_area()

    len_path=len(PATH)
    DIR_X,DIR_Y,DIR_Z=DIR_X/len_path,DIR_Y/len_path,DIR_Z/len_path

    
    from math import sqrt 
    AREA=sqrt(AREA)/len(PROFILE)
    inset_fix=1
    for n, i in enumerate(PROFILE):

        #bpy.ops.mesh.extrude_region_shrink_fatten( TRANSFORM_OT_shrink_fatten={"value": i[0]*-1 })
        #bpy.ops.mesh.inset(thickness=0.1, depth=0)
        if n == 0:
            shift = i[2]
            inset=i[0]

        else:
            shift = i[2]-PROFILE[n-1][2]
            inset=i[0]
            inset_fix=1/PROFILE[n-1][0]
            inset=i[0]


        mod=shift*shiftMOD*AREA*4*INV

        DIR = (DIR_X*mod,DIR_Y*mod,DIR_Z*mod)

        if gap and n!=0:
            bpy.ops.mesh.duplicate_move(TRANSFORM_OT_translate={"value": DIR })
            bpy.ops.mesh.extrude_region_move(TRANSFORM_OT_translate={"value": DIR })
            bpy.ops.transform.resize(value=(inset_fix, inset_fix, inset_fix) )
            bpy.ops.transform.resize(value=(inset, inset, inset) )
            
        else:
            if n!=0:
                bpy.ops.mesh.extrude_region_move(TRANSFORM_OT_translate={"value": DIR })
                bpy.ops.transform.resize(value=(inset_fix, inset_fix, inset_fix) )
                bpy.ops.transform.resize(value=(inset, inset, inset) )

    if automerge_changed: bpy.context.scene.tool_settings.use_mesh_automerge = True

    return ['OK', 'BPS'] # @@@ ERROR @@@

