import bpy
from . PS_EXTRUDER_GEN import EXTRUDER_GEN

from bpy.types import (
                        PropertyGroup,
                        Panel
                        )

from bpy.props import (
                        BoolProperty,
                        EnumProperty,
                        FloatProperty,
                        StringProperty,
                        IntProperty,
                        PointerProperty
                        )


class MESH_OT_ps_extruder(bpy.types.Operator):
    bl_idname = "mesh.ps_extruder_op"
    bl_label = "ps_extruder_op"
    bl_description = "POLYSWEEP IT"
    bl_options = {'REGISTER', 'UNDO'}

    shift : FloatProperty(name="Normal Scale", default=1.0)
    fuse : BoolProperty(name="fuse", default=False)
    gap : BoolProperty(name="gap", default=False)
    reverse : BoolProperty(name="reverse", default=False)
    
    @classmethod
    def poll(cls, context):
        obj = context.active_object
        return (obj and obj.type == 'MESH' and context.mode == 'EDIT_MESH')

    def draw(self, context):
        layout = self.layout
        box = layout.box()
        box.prop(self, "shift")
        box.prop(self, "fuse")
        box.prop(self, "gap")
        box.prop(self, "reverse")

    def invoke(self, context, event):
        result = self.action(context)
        if result[0]=='OK':
            return {'FINISHED'}   

        else:
            self.report(type = {'ERROR'}, message = result[1])
            return {'FINISHED' if result[0] == 'OK' else 'CANCELLED'}


    def execute(self,context):
        self.action(context)
        return {'FINISHED'} 

    def action(self, context):
        return EXTRUDER_GEN(self.shift,self.fuse,self.gap,self.reverse)