import bpy
from bpy.types import (
                        PropertyGroup,
                        Panel
                        )

from bpy.props import (
                        BoolProperty,
                        EnumProperty,
                        FloatProperty,
                        StringProperty,
                        IntProperty,
                        PointerProperty
                        )
   
from . PS_PROFILER import get_profile

class VIEW3D_PT_PS_GLOBAL_UI(Panel):
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_category = "PS_TOOLS"
    bl_label = "POLYSWEEPER"

    @classmethod
    def poll(cls, context):
        return ( context.active_object is not None and context.object.type == 'MESH'  )

    def draw(self, context):
        layout = self.layout
        layout.use_property_split = True
        
        layout.prop(context.scene.ps_props, "profile_OBJ")
        layout.operator("polysweeper.set_profile_obj", text="select profile face")


        layout.operator("mesh.ps_sweeper", text="> SWEEP >")
        layout.operator("mesh.ps_extruder_op", text="] EXTRUDE [")
        

