import bmesh
import bpy
from mathutils import Vector

def Grow_loop(edge):
    A_LOOP.add(edge)
    if not edge in SORTED_LOOP: SORTED_LOOP.append(edge)#test
    for v in edge.verts:
        links=v.link_edges
        for link in links:
            if (link in EL and link not in A_LOOP):
                A_LOOP.add(link)
                SORTED_LOOP.append(link)#test
                grow_loop(link)

def Cursor_edge(border_edge): #return edge under cursor       
        dist=set()
        CURSOR = bpy.context.scene.cursor.location # cursor location to orient edge loop
        for e in border_edge:
            mx=(e.verts[0].co.x + e.verts[1].co.x)/2
            my=(e.verts[0].co.y + e.verts[1].co.y)/2
            mz=(e.verts[0].co.z + e.verts[1].co.z)/2
            median= bpy.context.object.matrix_world @ Vector((mx,my,mz))
            dist.add((CURSOR - median).length)

        dist=min(dist) 
        start_edge=None
        for e in border_edge:
            mx=(e.verts[0].co.x + e.verts[1].co.x)/2
            my=(e.verts[0].co.y + e.verts[1].co.y)/2
            mz=(e.verts[0].co.z + e.verts[1].co.z)/2
            median= bpy.context.object.matrix_world @ Vector((mx,my,mz))
            if ((CURSOR - median).length != dist):
                e.select=False
            else:
                start_edge=e #A_LOOP START

        return start_edge

def BM():
    bm = bmesh.new()
    return bm.from_mesh(bpy.context.object.data)

def BM_ADD_FACES(bm,faces):
    for f in faces:
        verts=[]
        for v in f.verts:
            v1 = bm.verts.new((v.co.x,v.co.y,v.co.z))
            verts.append(v1)
        bm.faces.new(verts)
    return bm

def S_list(components):
    return [ i for i in components if i.select ]

def S_set(components):
    return set( i for i in components if i.select )

def JOIN(a,b):
    bpy.ops.object.select_all(action='DESELECT')
    a.select_set(True)
    b.select_set(True)
    bpy.ops.object.join()
    bpy.data.meshes.remove(bpy.data.meshes['PS_temp_mesh'])

def ADD_OBJ(bm,ps_mesh):
    #ps_mesh = bpy.data.meshes.new('PS_temp_mesh') 
    bm.to_mesh(ps_mesh)
    obj = bpy.data.objects.new('PS_temp_OBJ', ps_mesh)
    bpy.context.collection.objects.link(obj)
    return obj


def SELECTION_MASTER(S):
    return 0 # return array[ 0 ordered face array, 1 if any first edge, 2  if any last edge, 3 A_loop set, 4 B_loop set, 5 ring set]
