import bpy
import bmesh


#_____________________________________________________________
#___________________________________________MESH PROFILE STUFF
class MESH_OT_PS_profile_obj(bpy.types.Operator):
    bl_idname = "polysweeper.set_profile_obj"
    bl_label = ""
    bl_description = ''
    bl_context = 'mesh'
    bl_options = {'REGISTER', 'UNDO'}

    def execute(self, context):
        get_profile()
        return {'FINISHED'}


def ZLEN_MIN_MAX(prof_data):
    norm_prof = []
    PxMAX = set((v[0] for v in prof_data)); 
    PzMAX = set()
    PxMIN = min(PxMAX); PxMAX = max(PxMAX)  # MIN MAX X
    for v in prof_data:
        if (v[0] == PxMIN):
            PzMAX.add(v[2])
    PzMIN = min(PzMAX); PzMAX = max(PzMAX)  # MIN MAX Z
    Zlen = PzMAX-PzMIN  # Z lenght
    for v in prof_data:
        norm_prof.append((v[0]-PxMIN, v[1], v[2]-PzMAX))
    return (Zlen, PzMIN, PzMAX, norm_prof)


def FaceProfile():
    prof_data = bpy.context.scene.ps_props.profile_OBJ
    if prof_data == None: return "PICK PROFILE OBJECT"
    
    prof_data = prof_data.data
    
    S=[f for f in prof_data.polygons if f.select]

    if len(S) >1 or len(S) == 0: return "Select just one face from profile object"

    verts=[v for v in S[0].vertices]
    PROFILE=[]
    for v in verts:
        vert=prof_data.vertices[v].co
        PROFILE.append( (float (str (vert.x)[:5]),vert.y,vert.z) )
     
    CV=[] # CREASE VALUES 
                                   
    for v in verts:
        v=prof_data.vertices[v]
        if len(v.groups)!=0:
            CV.append(v.groups[0].weight)
        else:
            CV.append(0) 

    return PROFILE,CV



active_polysweeper_mesh = None

def get_profile():

    global active_polysweeper_mesh
    PROF_OBJ= bpy.context.scene.ps_props.profile_OBJ
    if PROF_OBJ == None: return "PICK PROFILE OBJECT"
    if PROF_OBJ and PROF_OBJ.select_get():
        
        bpy.ops.object.mode_set(mode='OBJECT')
        PROF_OBJ.select_set(False)
        active_polysweeper_mesh.select_set(True)
        bpy.context.view_layer.objects.active=active_polysweeper_mesh
        bpy.ops.object.mode_set(mode='EDIT')
        
    
    else:
        active_polysweeper_mesh =  bpy.context.object
        
        bpy.ops.object.mode_set(mode='OBJECT')
        if PROF_OBJ != None:
            PROF_OBJ.select_set(True)
            active_polysweeper_mesh.select_set(False) 
            bpy.context.view_layer.objects.active=PROF_OBJ
            
            bpy.ops.object.mode_set(mode='EDIT')
#_____________________________________________________________