import bpy
from . PS_SWEEP_GEN import SWEEP_GEN

from . PS_PROFILER import *

from bpy.types import (
                        PropertyGroup,
                        Panel
                        )

from bpy.props import (
                        BoolProperty,
                        EnumProperty,
                        FloatProperty,
                        StringProperty,
                        IntProperty,
                        PointerProperty
                        )


class MESH_OT_ps_sweeper(bpy.types.Operator):
    bl_idname = "mesh.ps_sweeper"
    bl_label = "ps_sweeper"
    bl_description = "POLYSWEEP IT"
    bl_options = {'REGISTER', 'UNDO'}

    UserValue : FloatProperty(name="Normal Scale", default=1.0)
    sweep : BoolProperty(name="Sweep Faces", default=True)
    close : BoolProperty(name="Caps", default=True)
    fuse : BoolProperty(name="fuse", default=False)
    toggle : BoolProperty(name="TOGGLE TO REFRESH", default=False)
    
    
    @classmethod
    def poll(cls, context):
        obj = context.active_object
        return (obj and obj.type == 'MESH' and context.mode == 'EDIT_MESH')

    def draw(self, context):
        layout = self.layout
        box = layout.box()
        #box.prop(self, "toggle")
        box.prop(self, "UserValue")
        box.prop(self, "sweep")
        box.prop(self, "close")
        box.prop(self, "fuse")
 
    def invoke(self, context, event):
        result = self.action(context)
        if result[0]=='OK':
            return {'FINISHED'}   

        else:
            self.report(type = {'ERROR'}, message = result[1])
            return {'FINISHED' if result[0] == 'OK' else 'CANCELLED'}


    def execute(self,context):
        self.action(context)
        return {'FINISHED'} 

    def action(self,context):
        return SWEEP_GEN(self.UserValue,self.sweep,self.close,self.fuse)




