# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTIBILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

bl_info = {
    "name" : "POLYSWEEPER_08LITE",
    "author" : "Andrea Rastelli",
    "description" : "polysweeper basic tool" ,
    "blender" : (2, 80, 0),
    "version" : (0, 0, 8),
    "location" : "View3D",
    "warning" : "IN DEVELOPMENT, USE WITH CAUTION",
    "category" : "Mesh"
}

import bpy

from . PS_SWEEP_OP import MESH_OT_ps_sweeper
from . PS_EXTRUDER_OP import MESH_OT_ps_extruder
from . PS_GLOBAL_PANEL import VIEW3D_PT_PS_GLOBAL_UI
from . PS_GLOBAL_PROPS import GLOBAL_UL_PS_props
from . PS_PROFILER import MESH_OT_PS_profile_obj
from . PS_PIE import VIEW3D_MT_PIE_PolysweeperPM
from bpy.props import PointerProperty

classes=(
    MESH_OT_ps_sweeper,
    MESH_OT_ps_extruder, 
    VIEW3D_PT_PS_GLOBAL_UI, 
    GLOBAL_UL_PS_props,
    MESH_OT_PS_profile_obj,
    VIEW3D_MT_PIE_PolysweeperPM
)

def register():

    from bpy.utils import register_class
    for cls in classes:
        register_class(cls)
    bpy.types.Scene.ps_props = PointerProperty(type = GLOBAL_UL_PS_props)
   

def unregister():

    from bpy.utils import unregister_class
    for cls in reversed(classes):
        unregister_class(cls)

if __name__ == "__main__":
    register()
